#ifndef GL_3D_jeremie
#define GL_3D_jeremie


#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "global.h"
#include "GLheader.h"
#include "world.h"
#include "interface.h"
#include "khepera_serial.h"



#ifdef ACTIVATE_TEXTURES
#include <tiffio.h>
#endif


//#include "checkpoint.h"


//extern from global.h(.cpp)
extern bool freeze;
extern bool display_sensor_around;
extern bool display_sensor_value;
extern bool display_sensor_window;
extern bool display_graphic_window;
extern int mode_follow;
extern int take_over;
extern bool show_name_robots;
extern Real cycle_simulation;

//extern from GL_3D.cpp
extern world world_GL;
extern GLfloat src_pos[];
extern GLint startx,starty,moving,instantInitial;
extern GLdouble oeilx,oeily,oeilz,visex,visey,visez;
extern int winIdMain,winIdSensors;
extern vector<int> win_asked_by_robots;
extern vector<robot*> owners_of_windows;


// EO related ???
extern int current_displaying;
extern bool arret_demande; //eoCtrlCContinue.cpp
extern void signal_handler( int sig );





//int sizex,sizey;

void Redisplay_all_graphics_windows();
void drawFunc(void);
void reshapeFunc(int w,int h);
void kbdFunc(unsigned char c, int x, int y);
void kbdSpecialFunc(int c, int x, int y);
void mouseFunc(int button, int state, int x, int y);
void motionFunc(int x, int y);



void idleFunc(void);


#ifdef ACTIVATE_TEXTURES
bool LoadTexTiff(char *fichier,int numtex);
#endif

void init();
void init_sensors();
void drawFunc_sensors(void);
void drawCam(void);
int ask_a_cam(class robot * _rob,string  _name,int _sx,int _sy);
int GL_world_initialisation(int argc, char *argv[],unsigned sx=800,unsigned sy=600,unsigned size_of_win_sensors=100);
int save_current_window(char * name);
void save_display_to_disk();
void Register_my_keyfunc(void (* func) (unsigned char c, int x, int y));
void Register_my_pre_idle_func(void (* func) (void) );
void Register_my_post_idle_func(void (* func) (void) );

	 


#endif
