//#include <iostream>  // istream, ostream
#include "math.h"
#include "global.h"
//#include <iostream>  // istream, ostream
//#include "eoRNInclude.h"
//#include "eoArchi.h"

#ifndef DONT_USE_EO
#include <eo>
#include "eoRN.h"

double sigmoid(double entree)
{
  double sortie = 1.0/(1.0+exp(-entree));
  
  return sortie;
}

double sigmoid_alpha(double entree, double alpha)
{
  double sortie = 1.0/(1.0+exp(-alpha*entree));  
  return sortie;
}

double trigger(double entree, double oldsortie)
{
  double sortie = 1.0/(1.0+exp(-entree));
  
  if ((oldsortie==0.0) && sortie > 0.75)
    sortie = 1.0;

  else if ((oldsortie==1.0) && sortie < 0.25)
    sortie = 0.0;

  else if ((oldsortie==0.0) && sortie < 0.75)
    sortie = 0.0;

  else if ((oldsortie==1.0) && sortie > 0.25)
    sortie = 1.0;

  return sortie;
}


double activationbraitenberg (double entree)
{
  
  double sortie;
  //   if (entree >= 0.0) sortie =1.0;
  // else sortie = 0.0;
  //sortie = (entree>=0.0) ? 0.55 : 0.5; //1.0
  // return sortie;
  
  sortie = 1.0/(1.0+exp(-3.0*entree));
  return sortie;
  
} 


ostream & operator << ( ostream& _os, const eoRNGenotype& _o ) {
_o.printOn(_os);
return _os;
}


istream & operator >> ( istream& _is, eoRNGenotype& _o ) {
  _o.readFrom(_is);
return _is;
}
#endif
