/** -*- mode: c++; c-indent-level: 4; c++-member-init-indent: 8; comment-column: 35; -*-
 */

#ifndef DONT_USE_EO

#ifndef _eoRNInclude_h
#define _eoRNInclude_h

#include "eoFunctor.h"
#include "eoEvalFunc.h"
#include <vector>
class world;

using namespace std;

class eoRealFunction// : public eoUF<vector<double> &, vector <double> >
// prend un vecteur de double et rend un double
{
    // elle doit donc definit la methode
  //  virtual vector<double>  operator() (vector<double> &); 
};

//class eoSimulation : public eoUF<eoRealFunction &, double>
//{
//};

template <class EOT> class eoEvalSimulation : public eoEvalFunc<EOT>
{
 public: 
    eoEvalSimulation (world &  _world_eo) :  world_eo(_world_eo) {}

    // Ctor: on lui passe la simulation
    void operator() (EOT & _genotype)
    {

      // typedef  typename EOT::Fitness Fit; //typename

      for (unsigned i=0;i<_genotype.number_of_robots;i++)
	{

	  if (world_eo.vector_robot[i]->type()=="khepera_EO") {
#ifdef _WIN32
		class khepera_EO * robot_provi =(static_cast<class khepera_EO *>( world_eo.vector_robot[i]));
#else
		class khepera_EO * robot_provi =(dynamic_cast<class khepera_EO *>( world_eo.vector_robot[i]));
#endif

		robot_provi->update_weights (_genotype.robots[i].poids);
	  }
	  
	  
	}
      double f;
      f=compute_fitness(&world_eo);
	  _genotype.fitness(f);
    }
 
 
 private:
  world & world_eo;

};


#endif
#endif
