#ifndef KHEPERA_EO_H
#define KHEPERA_EO_H

#include "global.h"

#ifndef DONT_USE_EO
//Define my kind of robot (An Khepera wich can be evolved)
#include "blackbox_EO.h"
#include "../../src/heart/simulator.h"

class khepera_EO: public khepera
{
public:
  // here are the 2 standards constructors of khepera 
khepera_EO(string _namerobot, Controller * _controller_base, Real _radius=27.5);
  

khepera_EO(string _namerobot, Controller * _controller_base, Real _centerx, Real _centery, Real _direction, Real _radius=27.5);
  
khepera_EO(string _namerobot, eoArchi * _archi, Controller * _controller_base, Real _radius=KHEPERA_DEFAULT_RADIUS);
  
  
khepera_EO(string _namerobot, eoArchi * _archi, Controller * _controller_base, vector<position_robot> _vector_pos_robot, Real _radius=KHEPERA_DEFAULT_RADIUS);
  

  
string type();
void update_weights (vector<double> & _poids);
~khepera_EO();


	 
vector<position_robot> vector_pos_robot;
bool set_pos;
unsigned step_epoch;
unsigned step_epoch_MAX;

//end of public for EO parameters
  
unsigned constructor;
blackbox_EO blackbox_robot_EO;
  
//  Controller_EO * controller;
//private:
};

#endif
#endif




