#include "interface.h"

#define MCB_LOAD_ENV 1
#define MCB_CLOSE    2

int winIdControl;

muiObject *b1;
muiObject *trb1, *trb2, *trb3, *trb4, *trb5; //small buttons
muiObject *ltrb0, *ltrb1, *ltrb2, *ltrb3, *ltrb4, *ltrb5; // labels for small buttons

muiObject *hs; //scrollbars
muiObject *lhs; //labels for scrollbars
muiObject *dial1, *label_dial1,*dial2, *label_dial2, *pd;

/*
int M1, M2, M3;	// menus 


void	controltltop(muiObject *obj, enum muiReturnValue value)
{
    float sliderval;

    if ((value != MUI_SLIDER_RETURN) && (value != MUI_SLIDER_THUMB)) return;
    sliderval = muiGetVSVal(obj);
    muiSetTLTop(tl, sliderval);
}

#define THUMBHEIGHT 20
#define ARROWSPACE 40

*/

int M1, M3;	// menus 

void menucallback(int x)
{
  switch(x)
	{
	case  MCB_LOAD_ENV :    	  break;
	case  MCB_CLOSE :  cout<<"Au revoir !"<<endl;exit(0); break;
	}
}


void makemenus(void)
{
    M1 = glutCreateMenu(menucallback);
    glutAddMenuEntry("Load a new environment", MCB_LOAD_ENV);
	glutAddMenuEntry("Close", MCB_CLOSE);


    M3 = glutCreateMenu(menucallback);
    glutAddMenuEntry("Help1", 7);
    glutAddMenuEntry("Help2", 8);
    glutAddMenuEntry("Help3", 9);

}

void bcallback(muiObject *obj, enum muiReturnValue r)
{
    obj = obj; r = r; /* for lint's sake */
    
	if (obj==trb1)
	  {
		display_sensor_around=!display_sensor_around;
	  }
	if (obj==trb2) {display_sensor_value=!display_sensor_value;}
	if (obj==trb3) {show_name_robots=!show_name_robots;}
	if (obj==trb4) {
	  display_sensor_window=!display_sensor_window;
	  muiSetEnable(trb2, (display_sensor_window==true));
	  if (display_sensor_window) {
		glutSetWindow(winIdSensors);
		glutShowWindow();}
	  else {
		glutSetWindow(winIdSensors);
		glutHideWindow();
	  }
	}
	
	if (obj==trb5) {
	  display_graphic_window=!display_graphic_window;
	  muiSetEnable(trb1, (display_graphic_window==true));
	  if (display_graphic_window) {
		glutSetWindow(winIdMain);
		glutShowWindow();}
	  else {
		glutSetWindow(winIdMain);
		glutHideWindow();
	  }
	}

	if (obj==b1) {freeze=!freeze;
	              if (freeze)
					{	muiLoadButton(b1, "UnFreeze");} else {
					  muiLoadButton(b1, "Freeze");}
					}

	/*
	if (obj==hs)
	  {
		char buf[5];
		sprintf(buf,"%.2f",muiGetVSVal(hs));
		muiChangeLabel(lhs,buf);
	  }
	*/

	if (obj==dial1)
	  {
		switch(r)
		  {
		  case  MUI_TEXTBOX_RETURN :
			cycle_simulation=(atof(muiGetTBString(dial1)));
			char buf[10];
			sprintf(buf,"%lg",cycle_simulation);
			muiSetTBString(dial1,buf);
			muiSetActive(dial1, 0);
			break;
		  case  MUI_NO_ACTION : break;
		  case  MUI_SLIDER_MOVE: break;
		  case	MUI_SLIDER_RETURN: break;
		  case	MUI_SLIDER_SCROLLDOWN: break;
		  case	MUI_SLIDER_SCROLLUP: break;
		  case	MUI_SLIDER_THUMB : break;
		  case	MUI_BUTTON_PRESS :	muiSetActive(dial1, 1); break;
		  case	MUI_TEXTLIST_RETURN : break;
		  case	MUI_TEXTLIST_RETURN_CONFIRM: break;
		
		  }
	  }
	
	if (obj==dial2)
	  {
		switch(r)
		  {
		  case  MUI_TEXTBOX_RETURN :
			GLenv_name=(muiGetTBString(dial2));
			muiSetTBString(dial2,GLenv_name);	
			muiSetActive(dial2,0);

			(world_GL.env)->load(GLenv_name);
			
			break;
		  case  MUI_NO_ACTION : break;
		  case  MUI_SLIDER_MOVE: break;
		  case	MUI_SLIDER_RETURN: break;
		  case	MUI_SLIDER_SCROLLDOWN: break;
		  case	MUI_SLIDER_SCROLLUP: break;
		  case	MUI_SLIDER_THUMB : break;
		  case	MUI_BUTTON_PRESS :	muiSetActive(dial2, 1); break;
		  case	MUI_TEXTLIST_RETURN : break;
		  case	MUI_TEXTLIST_RETURN_CONFIRM: break;
		
		  }
	  }
	
	
	

	
	//Redisplay  windows
	glutSetWindow(winIdControl);
	glutPostRedisplay();
	
	glutSetWindow(winIdSensors);
	glutPostRedisplay();
	
	glutSetWindow(winIdMain);
	glutPostRedisplay();
}
	

void makeui_display_according_to_curent_values()
{
  muiSetActive(trb1, (display_sensor_around==true));
  muiSetEnable(trb1, (display_graphic_window==true));
  
  muiSetActive(trb2, (display_sensor_value==true));
  muiSetEnable(trb2, (display_sensor_window==true));
  
  muiSetActive(trb3, (show_name_robots==true));
  
  muiSetActive(trb4, (display_sensor_window==true));
  
  muiSetActive(trb5, (display_graphic_window==true));
  
  
  if (freeze) {muiLoadButton(b1, "UnFreeze");} else {muiLoadButton(b1, "Freeze");}

   
  if (display_sensor_window) {
	glutSetWindow(winIdSensors);
	glutShowWindow();}
  else {
	glutSetWindow(winIdSensors);
	glutHideWindow();
  }
  
  if (display_graphic_window) {
	glutSetWindow(winIdMain);
	glutShowWindow();}
  else {
	glutSetWindow(winIdMain);
	glutHideWindow();
  }

  
  char buf[10];
  sprintf(buf,"%lg",cycle_simulation);
  muiSetTBString(dial1,buf);
  
  muiSetTBString(dial2,GLenv_name);	
}





void makeui(void)
{
  //int xmin, ymin, xmax, ymax;
	const int startm = 445;
	GLenv_name=new char[30];
	sprintf(GLenv_name,"built-in");
	
	
	makemenus();

	muiNewUIList(1);	/* makes an MUI display list (number 1) */

	ltrb1= muiNewBoldLabel( 10, startm,"Display Options");
	
    trb1 = muiNewTinyRadioButton(20, startm-25);
    muiLoadButton(trb1, "Sensors around the robots");
	muiSetCallback(trb1, bcallback);
	ltrb1= muiNewLabel( 240, startm-20,"(key : s)");
	

    trb2 = muiNewTinyRadioButton(20, startm-45);
    muiLoadButton(trb2, "Sensors values ");
	muiSetCallback(trb2, bcallback);
	ltrb2= muiNewLabel( 240, startm-40,"(key : v)");
	
    trb3 = muiNewTinyRadioButton(20, startm-65);
    muiLoadButton(trb3, "Names of the robots ");
	muiSetCallback(trb3, bcallback);
	ltrb3= muiNewLabel( 240, startm-60,"(key : n)");

	trb4 = muiNewTinyRadioButton(20, startm-85);
    muiLoadButton(trb4, "Sensor Window");
	muiSetCallback(trb4, bcallback);
	ltrb4= muiNewLabel( 240, startm-80,"(key : a)");

	trb5 = muiNewTinyRadioButton(20, startm-105);
    muiLoadButton(trb5, "Graphic Window");
	muiSetCallback(trb5, bcallback);
	ltrb5= muiNewLabel( 240, startm-100,"(key : z)");

	//muiLinkButtons(trb1, trb2);
    //muiLinkButtons(trb2, trb3);
	
	/* t = muiNewTextbox(110, 250, 50);
    muiSetActive(t, 1);
    t1 = muiNewTextbox(110, 270, 20);
    l = muiNewLabel(110, 85, "Label");
    l1 = muiNewBoldLabel(110, 110, "Bold Label");
    tl = muiNewTextList(20, 120, 200, 9);
	
	muiGetObjectSize(tl, &xmin, &ymin, &xmax, &ymax);
    vs = muiNewVSlider(xmax, ymin+2, ymax, 0, THUMBHEIGHT);
    hs = muiNewHSlider(20, 290, 280, 0, THUMBHEIGHT);
    muiSetVSValue(vs, 1.0);
    muiSetVSArrowDelta(vs, (ymax-ymin-10-THUMBHEIGHT-ARROWSPACE)/((sizeof strs)/(sizeof (char *))-9));
    muiLoadButton(b1, "Test");
    muiLoadButton(b2, "Test22");
    muiLoadButton(b3, "Test3");
    muiSetCallback(b3, bcallback);
    pd = muiNewPulldown();
    muiAddPulldownEntry(pd, "File", M1, 0);
    muiAddPulldownEntry(pd, "Edit", M2, 0);
    muiAddPulldownEntry(pd, "Help", M3, 1);
    muiSetTLStrings(tl, strs);
    muiSetCallback(vs, controltltop);
	*/


	/*
	hs = muiNewHSlider(20, 290, 280, 0, 2);
    muiSetVSValue(hs, 1.0);
	//muiSetCallback(hs, bcallback);
	lhs= muiNewLabel( 240, startm-150,"1.0");
	*/
	pd = muiNewPulldown();
	muiAddPulldownEntry(pd, "General", M1, 0);
    //muiAddPulldownEntry(pd, "Edit", M2, 0);
    muiAddPulldownEntry(pd, "Help", M3, 1);

	dial2 = muiNewTextbox(140, 270, 100);
	label_dial2= muiNewLabel(30,110,"Environment");
	muiSetTBString(dial2,GLenv_name);
	muiSetCallback(dial2, bcallback);
	
	
	dial1 = muiNewTextbox(180, 270, 60);
	label_dial1= muiNewLabel(30,70,"Time step (s) (key : +/-)");
	//label_dial1= muiNewLabel(30, 100,"test");
	char buf[10];
	sprintf(buf,"%lg",cycle_simulation);
	muiSetTBString(dial1,buf);
	muiSetCallback(dial1, bcallback);
	

	
	b1 = muiNewButton(110, 190, 20, 45);
	muiLoadButton(b1, "Freeze");
    muiSetCallback(b1, bcallback);

	
}
