#ifndef INTERFACE_H
#define INTERFACE_H

#include "global.h"
#include "world.h"
#include "GLheader.h"
//#include "GL_3D.h"
#include <iostream>

// in interface.cpp
extern int winIdControl;

// in GL_3D.cpp
extern int winIdMain;
extern int winIdSensors;
extern world world_GL;


// in global.cpp
extern bool freeze;
extern bool display_sensor_around;
extern bool display_sensor_value;
extern bool display_sensor_window;
extern bool show_name_robots;
extern Real cycle_simulation;
extern bool display_graphic_window;


// MUI Gestion (Simulator Control)
//--------------------------------------------------
extern int mui_singlebuffered;

/*
char *strs[] = { "Line 1", "Line 2", "Longer line 3", "Very, very, very long line number four", 
	    "Line 5", "Sixth line", "Seventh line", "Line number 8",  "9", "10", "The eleventh line", 
	    "line 12", "Line number 13", "Quite long line 14", "15",
	    "Line 1", "Line 2", "Longer line 3", "Very, very, very long line number four", 
	    "Line 5", "Sixth line", "Seventh line", "Line number 8",  "9", "10", "The eleventh line", 
	    "line 12", "Line number 13", "Quite long line 14", "15", 0, };

//muiObject *b1, *b2, *b3, *rb1, *rb2, *rb3, *t, *t1, *l, *l1, *vs, *tl;
//muiObject *trb1, *trb2, *trb3, *trb4, *trb5, *pd, *hs;
*/

// From interface.cpp
/*
extern muiObject *b1;
extern muiObject *trb1, *trb2, *trb3, *trb4, *trb5; //small buttons
extern muiObject *ltrb0, *ltrb1, *ltrb2, *ltrb3, *ltrb4, *ltrb5; // labels for small buttons

extern muiObject *hs; //scrollbars
extern muiObject *lhs; //labels for scrollbars
extern muiObject *dial1, *label_dial1;
*/

void bcallback(muiObject *obj, enum muiReturnValue r);

void makeui_display_according_to_curent_values();

void makeui(void);

#endif
