#ifndef _list_controllers_h
#define _list_controllers_h

#include "global.h"
#include "map_controllers.h"
#include "exception.h"

#include <vector>
#include <string>
using namespace std;


struct name_association
{
  string name;
  Controller * pointeur;
  
  name_association(string _name,Controller * _pointeur)
  {
	name=_name;
	pointeur=_pointeur;
  }
  
};




class map_controllers

{

 public:

  map_controllers ();
  void add_a_controller(string _s, Controller * _pointeur );
  

  Controller * operator() (string _s) //First we look if the controller is already allocated
    //that is to say, is the pointer NULL ? if not we dynimacally allocated
    //the matching controller

  {
	for (vector<name_association*>::iterator it1=(vector_of_controllers).begin();it1!=(vector_of_controllers).end();it1++) 
		  {
			if (_s==((*it1)->name) )
			  {
				return ((*it1)->pointeur);
			  }
		  }
		throw breakerror ("The name of your controller doesn't exist" + _s + "\n.");
  }

~map_controllers ()
  {
	for (vector<name_association*>::iterator it1=(vector_of_controllers).begin();it1!=(vector_of_controllers).end();it1++) 
		  {
			delete ((*it1)->pointeur);
		  }
  };
  
private:

  vector<name_association *> vector_of_controllers;
  

};



#endif
